'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function (workerRespawnDelay) {
    var queue = [];
    var timeout = undefined;

    var startIfNotAlreadyStarted = function startIfNotAlreadyStarted() {
        if (!timeout && queue.length) {
            timeout = setTimeout(processQueue, workerRespawnDelay);
        }
    };

    var processQueue = function processQueue() {
        timeout = null;
        if (queue.length) {
            var job = queue.shift();
            if (typeof job === 'function') {
                job();
            }
        }
        startIfNotAlreadyStarted();
    };

    return {
        push: function push(job) {
            queue.push(job);
            startIfNotAlreadyStarted();
        }
    };
};

module.exports = exports['default'];