'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function (_ref, server) {
    var log = _ref.log;
    var workerKillTimeout = _ref.workerKillTimeout;

    if (server && typeof server.close === 'function') {
        server.close(function () {
            return process.exit(1);
        });
    } else {
        log.warn('No server with .close() method received (yet?) from workerFunction. Exiting anyway in ' + workerKillTimeout + ' ms...');
        setTimeout(function () {
            return process.exit(1);
        }, workerKillTimeout);
    }
};

module.exports = exports['default'];