'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _cluster = require('cluster');

var _cluster2 = _interopRequireDefault(_cluster);

var _closeServerOrKillProcess = require('./close-server-or-kill-process');

var _closeServerOrKillProcess2 = _interopRequireDefault(_closeServerOrKillProcess);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (options, serverOrPromise) {
    var log = options.log;

    var isAlreadyCrashing = false;
    var server = undefined;

    if (serverOrPromise && typeof serverOrPromise.then === 'function') {
        serverOrPromise.then(function (actualServer) {
            if (isAlreadyCrashing) {
                (0, _closeServerOrKillProcess2.default)(options, actualServer);
            } else {
                server = actualServer;
            }
        });
    } else {
        server = serverOrPromise;
    }

    return function (err) {
        process.send('crashing');
        _cluster2.default.worker.disconnect();
        log.fatal('uncaughtException', err);
        isAlreadyCrashing = true;
        (0, _closeServerOrKillProcess2.default)(options, server);
    };
};

module.exports = exports['default'];